package einfhrendesbeispiel;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.util.*;
import java.text.*;

public class RuleBasedCollatorBeispiel {
   public static void sortStrings(Collator collator, String[] words) {
       String tmp;
       for (int i = 0; i < words.length; i++) {
           for (int j = i + 1; j < words.length; j++) {
               // Compare elements of the words array
               if( collator.compare(words[i], words[j] ) > 0 ) {
                   // Swap words[i] and words[j]
                   tmp = words[i];
                   words[i] = words[j];
                   words[j] = tmp;
               }
           }
       }
   }

   public static void printStrings(String [] words) {
       for (int i = 0; i < words.length; i++) {
          System.out.println(words[i]);
       }
   }

   static public void main(String[] args) {

      String englishRules =
         ("< a,A < b,B < c,C < d,D < e,E < f,F " +
          "< g,G < h,H < i,I < j,J < k,K < l,L " +
          "< m,M < n,N < o,O < p,P < q,Q < r,R " +
          "< s,S < t,T < u,U < v,V < w,W < x,X " +
          "< y,Y < z,Z");

      String smallnTilde  = new String("\u00F1");
      String capitalNTilde = new String("\u00D1");

      String traditionalSpanishRules =
         ("< a,A < b,B < c,C " +
          "< ch, cH, Ch, CH "  +
          "< d,D < e,E < f,F " +
          "< g,G < h,H < i,I < j,J < k,K < l,L " +
          "< ll, lL, Ll, LL "  +
          "< m,M < n,N " +
          "< " + smallnTilde + "," + capitalNTilde + " " +
          "< o,O < p,P < q,Q < r,R " +
          "< s,S < t,T < u,U < v,V < w,W < x,X " +
          "< y,Y < z,Z");

       String [] words = {
         "luz",
         "curioso",
         "llama",
         "chalina"
       };

       try {
           RuleBasedCollator enCollator =
              new RuleBasedCollator(englishRules);
           RuleBasedCollator spCollator =
              new RuleBasedCollator(traditionalSpanishRules);

          System.out.println("RuleBasedCollator : ");
          System.out.println("unsortierte Wrter");
          for (int i=0; i<words.length; i++)
            System.out.print(words[i]+" ");
          System.out.println();
          System.out.println();

          System.out.println("Englisch sortiert");
           sortStrings(enCollator, words);
           printStrings(words);

           System.out.println();

          System.out.println("Traditionell Spanisch sortiert");
           sortStrings(spCollator, words);
           printStrings(words);
       } catch (ParseException pe) {
           System.out.println("Parse Exception ");
       }
   }
}
