package bitset;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.util.BitSet;

public class Main {
    private static void initBitSets(BitSet e, BitSet f) {
        for(int i = 0; i < 10; i++)
            e.set(i);
        for (int i = 5; i <15; i++)
            f.set(i);
        System.out.println("englisch: " + e);
        System.out.println("franzsisch: " + f);
    }
    public static void main(String[] args) {
        BitSet english = new BitSet(100);  // tracks Englische Speakers
        BitSet french = new BitSet(100);   // tracks Fanzsische speakers

        // Initialisierung
        initBitSets(english, french);

        BitSet bilingual = (BitSet)english.clone();
        bilingual.and(french);

        if (bilingual.equals(english))
            // die gesamte Englisch Klasse ist bilingual
            System.out.println("Bilingual Klasse");
        else
            System.out.println("Bilingual: " + bilingual.toString());

        BitSet either = (BitSet)english.clone();
        either.or(french);
        int eitherCount = 0;

        // wieviele sind Englisch, Franzsisch oder beides
        for (int i=0; i < either.size(); i++) {
            if (either.get(i))
                ++eitherCount;
        }
        System.out.println("Irgendeine(" + eitherCount + "):" + either);

        // wieviele sind Englisch, Franzsisch aber nicht beides
        BitSet one = (BitSet)english.clone();
        one.xor(french);
        System.out.println("Eine: " + one);

        // anderer Weg :
        // eliminiere die zweisprachigen aus either

        // fast track
        one = (BitSet)either.clone();
        one.xor(bilingual);
        System.out.println("Eine (fast Track):" + one);

        // slow track
        one = (BitSet)either.clone();
        for (int i = 0; i < one.size(); i++)
            if (bilingual.get(i))
                one.clear(i);
        System.out.println("Eine (slow Track):" + one);
    }
}
