package synchronizedcollection;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
import java.util.*;

class Reader extends Thread {
    Collection col;
    Reader(Collection c) {
        col = c;
    }
    public void run() {
        while (true) {
            synchronized(col) {
                for (Iterator i=col.iterator(); i.hasNext(); ) {
                    System.out.print(i.next()+" ");
                    Thread.yield();
                }
                System.out.println();
            }
        }
    }
}

class Writer extends Thread {
    static Random rnd = new Random();
    Collection col;
    Writer(Collection c) {
        col = c;
    }
    public void run() {
        while (true) {
            Integer ri = new Integer(rnd.nextInt(10));
            if (rnd.nextBoolean()) {
                col.add(ri);
            } else {
                col.remove(ri);
            }
            Thread.yield();
        }
    }
}
