package addobserver;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.util.Observable;
import java.util.Observer;

public class Main {
    final static int white = 0;
    final static int red = 1;
    final static int blue = 2;

    public static void main(String[] args) {
        FarbObservable colors = new FarbObservable();
        Statistician counter = new Statistician(3);

        // Observers zuordnen
        colors.addObserver(counter);
        colors.addObserver(new Echoer());
        System.out.println("Anzahl Observers: " + colors.countObservers());

        //  Observable verndern
        colors.changeColor(blue);
        colors.changeColor(white);
        colors.changeColor(red);
        colors.changeColor(blue);

        counter.report();

        // einen Observer entfernen
        colors.deleteObserver(counter);
        System.out.println("Anzahl Observers: " + colors.countObservers());
        // entferne alle Observers
        colors.deleteObservers();
        System.out.println("Anzahl Observers: " + colors.countObservers());
    }
}
