package observable;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.util.Observer;
import java.util.Observable;

// Observer zhlt, wie oft auf Integer 'arg' zugegriffen wird
class Statistician implements Observer {
    private int[] counts;
    Statistician(int array_size) {
        counts = new int[array_size];
    }
    public void update(Observable o, Object arg) {
        Integer int_obj = (Integer)arg;
        if (int_obj.intValue() < counts.length)
            ++counts[int_obj.intValue()];
    }
    public void report() {
        System.out.println("nderungsrecord: ");
        for (int i = 0; i < counts.length; i++)
            System.out.println(ColorObservable.colorName(i) + ": " + counts[i]);
    }
}

// Observer produziert Ausdruck wann immer darauf zugegriffen wird
class Echoer implements Observer {
    int current_color;
    public void update(Observable o, Object arg) {
        int new_color = ((Integer)arg).intValue();
        System.out.println("Von " +
                           ColorObservable.colorName(current_color) +
                           " auf " +
                           ColorObservable.colorName(new_color));
        current_color = new_color;
    }
}

class ColorObservable extends Observable {
    public static String colorName(int i) {
        switch (i) {
        case 1: return ("rot");
        case 0: return ("weiss");
        case 2: return ("blau");
        default: return (null);
            }
    }
    public void changeColor(int i) {
        setChanged();
        notifyObservers(new Integer(i));
        clearChanged(); // nicht ntig; notifyObservers() reicht
    }
}
