package timertask;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.util.Timer;
import java.util.TimerTask;
import java.awt.Toolkit;

/**
 * Schedule einer Task die einmal pro Sekunde ausgefhrt wird
 */

public class AnnoyingBeep {
    Toolkit toolkit;
    Timer timer;

    public AnnoyingBeep() {
	toolkit = Toolkit.getDefaultToolkit();
        timer = new Timer();
        timer.schedule(new RemindTask(),
	               0,        //Anfangsverzgerung
	               1*1000);  //Wiederholung
    }

    class RemindTask extends TimerTask {
	int numWarningBeeps = 3;

        public void run() {
	    if (numWarningBeeps > 0) {
	        toolkit.beep();
		System.out.println("Beep!");
		numWarningBeeps--;
	    } else {
	        toolkit.beep();
                System.out.println("Die Zeit ist abgelaufen!");
	        //timer.cancel(); //nicht ntig:  System.exit
	        System.exit(0);   //Stoppen des AWT Thread
	    }
        }
    }

    public static void main(String args[]) {
	System.out.println("Task Scheduling.");
        new AnnoyingBeep();
	System.out.println("Task wurde gescheduled.");
    }
}
